Subject: bug#47067: 28.0.50; [feature/native-comp] Crash while scrolling through dispnew.c

From: Andrea Corallo <[email-masked]>
Date: Sat, 13 Mar 2021 19:51:59 +0000

Eli Zaretskii <[email-masked]> writes:

>> From: Andrea Corallo <[email-masked]>
>> Cc: [email-masked]
>> Date: Fri, 12 Mar 2021 20:21:26 +0000
>>
>> > I'd like to compare your backtrace with what I get here.
>>
>> Mmmh, my Emacs on the 32bit system I prepared when running interactively
>> under gdb is unusable because all keys except the basic letters are
>> mixed-up.  I never experienced this, is this common?  How can I solve
>> it?
>
> Rebuild Emacs not under GDB.  I think the breakpoints and other stuff
> you set up in GDB get dumped into the pdmp file, and thus render the
> dumped Emacs not very usable.  I always rebuild Emacs when I let it
> dump itself (which happens rarely, because I rarely have to debug
> temacs).
>
> If the above doesn't help, it could be that some of the *.eln files
> are damaged for similar reasons, so maybe remove them and let Emacs
> recompile them as well.
>
> If none of the above helps, please describe how did you "prepare Emacs
> on the 32bit system when running interactively under GDB", maybe I
> don't understand what exactly you did there.

I've done nothing special, I've just a regular wide-int 32bit build on
the virtual machine I've prepared, running interactivelly Emacs underg
gdb is unusable for the reason I've described (outside gdb it works
perfectly).  I think it has nothing to do with native compilation.

> Meanwhile, could you please post the backtrace I asked for from the
> 64-bit build?  Maybe it will tell me enough to get some ideas.

Here it is:

#0  Fskip_chars_backward (string=0xd7f594, lim=0x0) at syntax.c:1610
#1  0x00007ffff2ce170d in F632d6261636b776172642d737773_c_backward_sws_0 () from /home/andcor03/.emacs.d/eln-cache/28.0.50-85dc790d/cc-engine-ccfcb170-1b345b21.eln
#2  0x000000000052445b in Ffuncall (nargs=1, args=0x7fffffff74e0) at eval.c:3009
#3  0x00007ffff2dfe124 in F632d666c2d6465636c2d656e64_c_fl_decl_end_0 () from /home/andcor03/.emacs.d/eln-cache/28.0.50-85dc790d/cc-mode-515a98a5-c7761ade.eln
#4  0x00000000005274f0 in funcall_lambda (fun=0xdc4cc5, nargs=1, arg_vector=0x7fffffff7618) at lisp.h:731
#5  0x00000000005242fd in Ffuncall (nargs=2, args=0x7fffffff7610) at eval.c:3025
#6  0x00007ffff2dfec94 in F632d636f6e746578742d657870616e642d666c2d726567696f6e_c_context_expand_fl_region_0 ()
   from /home/andcor03/.emacs.d/eln-cache/28.0.50-85dc790d/cc-mode-515a98a5-c7761ade.eln
#7  0x00000000005274f0 in funcall_lambda (fun=0xdc4d65, nargs=2, arg_vector=0x7fffffff7738) at lisp.h:731
#8  0x00000000005242fd in Ffuncall (nargs=3, args=0x7fffffff7730) at eval.c:3025
#9  0x00007ffff2dfee34 in F616e6f6e796d6f75732d6c616d626461_anonymous_lambda_62 () from /home/andcor03/.emacs.d/eln-cache/28.0.50-85dc790d/cc-mode-515a98a5-c7761ade.eln
#10 0x00000000005274f0 in funcall_lambda (fun=0xcbd8c5, nargs=1, arg_vector=0x7fffffff7848) at lisp.h:731
#11 0x00000000005242fd in Ffuncall (nargs=2, args=0x7fffffff7840) at eval.c:3025
#12 0x000000000052450a in call1 (fn=<optimized out>, arg1=<optimized out>) at eval.c:2869
#13 0x000000000052e6e4 in mapcar1 (leni=1, vals=vals@entry=0x0, fn=fn@entry=0xcbd8c5, seq=seq@entry=0xe111d3) at lisp.h:731
#14 0x0000000000530655 in Fmapc (function=0xcbd8c5, sequence=0xe111d3) at fns.c:2867
#15 0x000000000052445b in Ffuncall (nargs=3, args=0x7fffffff7930) at eval.c:3009
#16 0x00007ffff2dfef77 in F632d6265666f72652d636f6e746578742d666c2d657870616e642d726567696f6e_c_before_context_fl_expand_region_0 ()
   from /home/andcor03/.emacs.d/eln-cache/28.0.50-85dc790d/cc-mode-515a98a5-c7761ade.eln
#17 0x00000000005274f0 in funcall_lambda (fun=0xdc4db5, nargs=2, arg_vector=0x7fffffff7ae8) at lisp.h:731
#18 0x00000000005242fd in Ffuncall (nargs=3, args=0x7fffffff7ae0) at eval.c:3025
#19 0x00007ffff2dff40f in F632d666f6e742d6c6f636b2d666f6e746966792d726567696f6e_c_font_lock_fontify_region_0 ()
   from /home/andcor03/.emacs.d/eln-cache/28.0.50-85dc790d/cc-mode-515a98a5-c7761ade.eln
#20 0x00000000005274f0 in funcall_lambda (fun=0xdc4e05, nargs=3, arg_vector=0x7fffffff7c68) at lisp.h:731
#21 0x00000000005242fd in Ffuncall (nargs=4, args=0x7fffffff7c60) at eval.c:3025
#22 0x00007ffff40c06b5 in F666f6e742d6c6f636b2d666f6e746966792d726567696f6e_font_lock_fontify_region_0 ()
   from /home/andcor03/emacs2/src/../native-lisp/28.0.50-85dc790d/font-lock-895216f6-4cc69ac6.eln
#23 0x000000000052445b in Ffuncall (nargs=3, args=0x7fffffff7d20) at eval.c:3009
#24 0x000000000055da00 in exec_byte_code (bytestr=<optimized out>, vector=<optimized out>, maxdepth=<optimized out>, args_template=<optimized out>, nargs=<optimized out>,
    args=<optimized out>) at bytecode.c:632
#25 0x00000000005242fd in Ffuncall (nargs=2, args=0x7fffffff80b0) at eval.c:3025
#26 0x00000000005244bc in run_hook_wrapped_funcall (nargs=<optimized out>, args=0x7fffffff80b0) at eval.c:2746
#27 0x0000000000523b3d in run_hook_with_args (nargs=2, args=0x7fffffff80b0, funcall=0x5244a0 <run_hook_wrapped_funcall>) at eval.c:2827
#28 0x00007ffff4318bc5 in F6a69742d6c6f636b2d2d72756e2d66756e6374696f6e73_jit_lock__run_functions_0 ()
   from /home/andcor03/emacs2/src/../native-lisp/28.0.50-85dc790d/jit-lock-8a988e43-73eb7028.eln
#29 0x000000000052445b in Ffuncall (nargs=3, args=0x7fffffff8200) at eval.c:3009
#30 0x00007ffff4319521 in F6a69742d6c6f636b2d666f6e746966792d6e6f77_jit_lock_fontify_now_0 ()
   from /home/andcor03/emacs2/src/../native-lisp/28.0.50-85dc790d/jit-lock-8a988e43-73eb7028.eln-----------------------------------------------------------------------------
#31 0x000000000052445b in Ffuncall (nargs=3, args=0x7fffffff8350) at eval.c:3009
#32 0x00007ffff431894d in F6a69742d6c6f636b2d66756e6374696f6e_jit_lock_function_0 ()
   from /home/andcor03/emacs2/src/../native-lisp/28.0.50-85dc790d/jit-lock-8a988e43-73eb7028.eln
#33 0x000000000052445b in Ffuncall (nargs=nargs@entry=2, args=args@entry=0x7fffffff8440) at eval.c:3009
#34 0x00000000005236c9 in internal_condition_case_n (bfun=0x524190 <Ffuncall>, nargs=2, args=0x7fffffff8440, handlers=<optimized out>, hfun=0x4330e0 <safe_eval_handler>)
    at eval.c:1612
#35 0x0000000000427a50 in safe__call (inhibit_quit=inhibit_quit@entry=false, nargs=nargs@entry=2, func=<optimized out>, ap=ap@entry=0x7fffffff84b8) at lisp.h:1002
#36 0x0000000000432305 in safe_call (nargs=nargs@entry=2, func=<optimized out>) at xdisp.c:2996
#37 0x000000000043244f in safe_call1 (arg=0x1f10a, fn=<optimized out>) at xdisp.c:3007
#38 handle_fontified_prop (it=0x7fffffff8700) at xdisp.c:4313
#39 handle_fontified_prop (it=0x7fffffff8700) at xdisp.c:4250
#40 0x0000000000434bfd in handle_stop (it=0x7fffffff8700) at xdisp.c:3841
#41 0x000000000044f2d2 in redisplay_window (window=<optimized out>, just_this_one_p=<optimized out>) at xdisp.c:18960
#42 0x0000000000452f2b in redisplay_window_0 (window=window@entry=0xb6228d) at xdisp.c:16581
#43 0x00000000005234e4 in internal_condition_case_1 (bfun=0x452f00 <redisplay_window_0>, arg=0xb6228d, handlers=<optimized out>, hfun=0x4276f0 <redisplay_window_error>)
    at eval.c:1472
#44 0x0000000000429791 in redisplay_windows (window=0xb6228d) at xdisp.c:16561
#45 0x0000000000448e65 in redisplay_internal () at xdisp.c:16029
#46 0x000000000044abd0 in redisplay_preserve_echo_area (from_where=<optimized out>) at xdisp.c:16378
#47 0x0000000000418fdf in Fredisplay (force=<optimized out>) at dispnew.c:6157
#48 Fredisplay (force=0x0) at dispnew.c:6135
#49 0x00007ffff44facc2 in F7369742d666f72_sit_for_0 () from /home/andcor03/emacs2/src/../native-lisp/28.0.50-85dc790d/subr-13adf6a6-4a99f497.eln
#50 0x000000000052445b in Ffuncall (nargs=2, args=0x7fffffffd5b0) at eval.c:3009
#51 0x00007ffff408705d in F697365617263682d6c617a792d686967686c696768742d6e65772d6c6f6f70_isearch_lazy_highlight_new_loop_0 ()
   from /home/andcor03/emacs2/src/../native-lisp/28.0.50-85dc790d/isearch-693bdd75-d165ea70.eln
#52 0x000000000052445b in Ffuncall (nargs=1, args=0x7fffffffd750) at eval.c:3009
#53 0x00007ffff40772fd in F697365617263682d757064617465_isearch_update_0 () from /home/andcor03/emacs2/src/../native-lisp/28.0.50-85dc790d/isearch-693bdd75-d165ea70.eln
#54 0x000000000052445b in Ffuncall (nargs=1, args=0x7fffffffd920) at eval.c:3009
#55 0x00007ffff4080ec4 in F697365617263682d7365617263682d616e642d757064617465_isearch_search_and_update_0 ()
   from /home/andcor03/emacs2/src/../native-lisp/28.0.50-85dc790d/isearch-693bdd75-d165ea70.eln
#56 0x000000000052445b in Ffuncall (nargs=1, args=0x7fffffffd9d8) at eval.c:3009
#57 0x00007ffff4082ead in F697365617263682d70726f636573732d7365617263682d737472696e67_isearch_process_search_string_0 ()
   from /home/andcor03/emacs2/src/../native-lisp/28.0.50-85dc790d/isearch-693bdd75-d165ea70.eln
#58 0x000000000052445b in Ffuncall (nargs=3, args=0x7fffffffdac0) at eval.c:3009
#59 0x00007ffff4082cf9 in F697365617263682d70726f636573732d7365617263682d63686172_isearch_process_search_char_0 ()
   from /home/andcor03/emacs2/src/../native-lisp/28.0.50-85dc790d/isearch-693bdd75-d165ea70.eln
#60 0x000000000052445b in Ffuncall (nargs=3, args=0x7fffffffdbc0) at eval.c:3009
#61 0x00007ffff4082bb5 in F697365617263682d7072696e74696e672d63686172_isearch_printing_char_0 ()
   from /home/andcor03/emacs2/src/../native-lisp/28.0.50-85dc790d/isearch-693bdd75-d165ea70.eln
#62 0x000000000052445b in Ffuncall (nargs=3, args=0x7fffffffdcf8) at eval.c:3009
#63 0x0000000000520c31 in Ffuncall_interactively (nargs=3, args=0x7fffffffdcf8) at callint.c:260
#64 0x000000000052445b in Ffuncall (nargs=4, args=0x7fffffffdcf0) at eval.c:3009
#65 0x0000000000526210 in Fapply (nargs=3, args=0x7fffffffde40) at eval.c:2639
#66 0x00000000005222ae in Fcall_interactively (function=0x7ffff3f38050, record_flag=0x0, keys=0x1040f35) at callint.c:353
#67 0x00007ffff43b7a51 in F636f6d6d616e642d65786563757465_command_execute_0 () from /home/andcor03/emacs2/src/../native-lisp/28.0.50-85dc790d/simple-fab5b0cf-9fc01ab7.eln
#68 0x000000000052445b in Ffuncall (nargs=2, args=0x7fffffffdfc0) at eval.c:3009
#69 0x000000000052450a in call1 (fn=<optimized out>, arg1=<optimized out>) at eval.c:2869
#70 0x00000000004b9846 in command_loop_1 () at lisp.h:1002
#42 0x0000000000452f2b in redisplay_window_0 (window=window@entry=0xb6228d) at xdisp.c:16581
#43 0x00000000005234e4 in internal_condition_case_1 (bfun=0x452f00 <redisplay_window_0>, arg=0xb6228d, handlers=<optimized out>, hfun=0x4276f0 <redisplay_window_error>)
    at eval.c:1472
#44 0x0000000000429791 in redisplay_windows (window=0xb6228d) at xdisp.c:16561
#45 0x0000000000448e65 in redisplay_internal () at xdisp.c:16029
#46 0x000000000044abd0 in redisplay_preserve_echo_area (from_where=<optimized out>) at xdisp.c:16378
#47 0x0000000000418fdf in Fredisplay (force=<optimized out>) at dispnew.c:6157
#48 Fredisplay (force=0x0) at dispnew.c:6135
#49 0x00007ffff44facc2 in F7369742d666f72_sit_for_0 () from /home/andcor03/emacs2/src/../native-lisp/28.0.50-85dc790d/subr-13adf6a6-4a99f497.eln
#50 0x000000000052445b in Ffuncall (nargs=2, args=0x7fffffffd5b0) at eval.c:3009
#51 0x00007ffff408705d in F697365617263682d6c617a792d686967686c696768742d6e65772d6c6f6f70_isearch_lazy_highlight_new_loop_0 ()
   from /home/andcor03/emacs2/src/../native-lisp/28.0.50-85dc790d/isearch-693bdd75-d165ea70.eln
#52 0x000000000052445b in Ffuncall (nargs=1, args=0x7fffffffd750) at eval.c:3009
#53 0x00007ffff40772fd in F697365617263682d757064617465_isearch_update_0 () from /home/andcor03/emacs2/src/../native-lisp/28.0.50-85dc790d/isearch-693bdd75-d165ea70.eln
#54 0x000000000052445b in Ffuncall (nargs=1, args=0x7fffffffd920) at eval.c:3009
#55 0x00007ffff4080ec4 in F697365617263682d7365617263682d616e642d757064617465_isearch_search_and_update_0 ()
   from /home/andcor03/emacs2/src/../native-lisp/28.0.50-85dc790d/isearch-693bdd75-d165ea70.eln
#56 0x000000000052445b in Ffuncall (nargs=1, args=0x7fffffffd9d8) at eval.c:3009
#57 0x00007ffff4082ead in F697365617263682d70726f636573732d7365617263682d737472696e67_isearch_process_search_string_0 ()
   from /home/andcor03/emacs2/src/../native-lisp/28.0.50-85dc790d/isearch-693bdd75-d165ea70.eln
#58 0x000000000052445b in Ffuncall (nargs=3, args=0x7fffffffdac0) at eval.c:3009
#59 0x00007ffff4082cf9 in F697365617263682d70726f636573732d7365617263682d63686172_isearch_process_search_char_0 ()
   from /home/andcor03/emacs2/src/../native-lisp/28.0.50-85dc790d/isearch-693bdd75-d165ea70.eln
#60 0x000000000052445b in Ffuncall (nargs=3, args=0x7fffffffdbc0) at eval.c:3009
#61 0x00007ffff4082bb5 in F697365617263682d7072696e74696e672d63686172_isearch_printing_char_0 ()
   from /home/andcor03/emacs2/src/../native-lisp/28.0.50-85dc790d/isearch-693bdd75-d165ea70.eln
#62 0x000000000052445b in Ffuncall (nargs=3, args=0x7fffffffdcf8) at eval.c:3009
#63 0x0000000000520c31 in Ffuncall_interactively (nargs=3, args=0x7fffffffdcf8) at callint.c:260
#64 0x000000000052445b in Ffuncall (nargs=4, args=0x7fffffffdcf0) at eval.c:3009
#65 0x0000000000526210 in Fapply (nargs=3, args=0x7fffffffde40) at eval.c:2639
#66 0x00000000005222ae in Fcall_interactively (function=0x7ffff3f38050, record_flag=0x0, keys=0x1040f35) at callint.c:353
#67 0x00007ffff43b7a51 in F636f6d6d616e642d65786563757465_command_execute_0 () from /home/andcor03/emacs2/src/../native-lisp/28.0.50-85dc790d/simple-fab5b0cf-9fc01ab7.eln
#68 0x000000000052445b in Ffuncall (nargs=2, args=0x7fffffffdfc0) at eval.c:3009
#69 0x000000000052450a in call1 (fn=<optimized out>, arg1=<optimized out>) at eval.c:2869
#70 0x00000000004b9846 in command_loop_1 () at lisp.h:1002
--Type <RET> for more, q to quit, c to continue without paging--
#71 0x0000000000523457 in internal_condition_case (bfun=0x4b9490 <command_loop_1>, handlers=<optimized out>, hfun=0x4b0770 <cmd_error>) at eval.c:1448
#72 0x00000000004ab5ec in command_loop_2 (ignore=ignore@entry=0x0) at lisp.h:1002
#73 0x0000000000525913 in internal_catch (tag=0xca80, func=0x4ab5d0 <command_loop_2>, arg=0x0) at eval.c:1198
#74 0x00000000004ab594 in command_loop () at lisp.h:1002
#75 0x00000000004b0391 in recursive_edit_1 () at keyboard.c:720
#76 0x00000000004b06b3 in Frecursive_edit () at keyboard.c:789
#77 0x0000000000418036 in main (argc=<optimized out>, argv=<optimized out>) at emacs.c:2095

Thanks

  Andrea